# Timing Diagram

![Timing Diagram (from uml-diagram.org)](https://341919671-files.gitbook.io/~/files/v0/b/gitbook-legacy-files/o/assets%2F-L9shwSMiocGHpSKcbss%2F-MI2z8LM-A3B2GC8cFv7%2F-MI2z3dRhLl5jp1VghUI%2FWebsite%20Timing.png?alt=media\&token=b4574b52-3eaf-43c8-b28f-1969df90d0a8)

## Create Timing Diagram

To create a Timing Diagram:

1. Select first an element where a new Timing Diagram to be contained as a child.
2. Select **Model | Add Diagram | Timing Diagram** in Menu Bar or select **Add Diagram | Timing Diagram** in Context Menu.

> **See also**
>
> [UML Timing Diagram](https://www.uml-diagrams.org/timing-diagrams.html) - For more information about UML Timing Diagram.

## Lifeline

To create a Lifeline:

1. Select **Lifeline** in **Toolbox**.
2. Drag on the diagram as the size of Lifeline.

To create a Lifeline from a Classifier (Class, Interface, etc.) by Drag-and-Drop:

1. Drag a Classifier from **Explorer**.
2. Drop on the diagram.

You can use **QuickEdit** for Lifeline by double-click or press `Enter` on a selected Lifeline.

* **Lifeline Expression** : Edit lifeline expression.
* **Visibility** : Change visibility property.
* **Select Type** : Select a type of the lifeline.
* **Create Type** : Create a Class as a type of the lifeline.
* **Create State/Condition** : Create a State/Condition on the lifeline.

## State/Condition

To create a State/Condition:

1. Select **State/Condition** in **Toolbox**.
2. Click on a Lifeline on the diagram.

You can use **QuickEdit** for State/Condition by double-click or press `Enter` on a selected State/Condition.

* **Name Expression** : Edit state/condition name.
* **Visibility** : Change visibility property.
* **Create Time Segment** : Create a Time Segment on the State/Condition.

## Time Segment

To create a Time Segment

1. Select **Time Segment** in **Toolbox**.
2. Click on a State/Condition area on the diagram.

## Time Tick

To create a Time Tick

1. Select **Time Tick** in **Toolbox**.
2. Click on the Timing Diagram Frame area on the diagram.

## Time Constraint

To create a Time Constraint

1. Select **Time Constraint** in **Toolbox**.
2. Click on an element (e.g. Message or Time Segment) to attach a time constraint on the diagram.

## Duration Constraint

To create a Duration Constraint

1. Select **Duration Constraint** in **Toolbox**.
2. Drag on the diagram as the size of Duration Constraint.

## Message

To create a Message:

1. Select **Message** in **Toolbox**.
2. Drag from a Time Segment and drop on another Time Segment.

For more about Message, visit the [Message](https://docs.staruml.io/v5/sequence-diagram#message) section in Sequence Diagram.


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.staruml.io/v5/working-with-uml-diagrams/timing-diagram.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
